import BasePagination from '@/components/sagacloud/BasePagination'
import TableTemplate from '@/framework/template/TablePageTemplate'
import SgSelector from '@/components/sagacloud/SgSelector'
//tools
import basicutils from '@/utils/basicutils'
import httputils from '@/utils/httputils.js'

export default {
    install: function(Vue) {
        Vue.prototype.initPagination = function() {
            return {
                pageSize: 10,
                pageSizes: [10, 20, 50, 100, 200, 500],
                layout: 'total, sizes, prev, pager, next, jumper',
                total: 0,
                currentPage: 1,
                data: [],
                params: {}
            }
        }
        Vue.component('base-pagination', BasePagination)
        Vue.component('table-page-template', TableTemplate)
        Vue.component('sg-selector', SgSelector)

        Vue.prototype.formatDate = function(date) {
            return basicutils.formatDateByPattern(date, 'yyyy-MM-dd HH:mm:ss')
        }

        Vue.prototype.hasPermission = function(promise) {
            return basicutils.hasPermission(promise)
        }

        /**http plugins */
        // 添加全局方法
        Vue.prototype.getJson = httputils.getJson

        Vue.prototype.postJson = httputils.postJson

        Vue.prototype.download = httputils.download

        Vue.filter('formatDateForMillisecond', function(value) {
            if (!value) return ''
            return basicutils.formatDateByPattern(new Date(value), 'yyyy-MM-dd')
        })

        Vue.filter('formatDateTimeForMillisecond', function(value) {
            if (!value) return ''
            return basicutils.formatDateByPattern(new Date(value), 'yyyy-MM-dd HH:mm:ss')
        })
    }
}
